diff -Naur usbip-0.1.4/src/cmd/vhci_attach.c trunk/src/cmd/vhci_attach.c
--- usbip-0.1.4/src/cmd/vhci_attach.c	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/cmd/vhci_attach.c	2007-05-18 11:10:07.000000000 +0200
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2005-2006 Takahiro Hirofuchi
+ * Copyright (C) 2005-2007 Takahiro Hirofuchi
  */
 
 #ifdef HAVE_CONFIG_H
@@ -18,36 +18,36 @@
 
 
 /* /sys/devices/platform/vhci_hcd/usb6/6-1/6-1:1.1  -> 1 */
-static int get_interface_number(struct usbip_vhci_driver *driver, char *path)
+static int get_interface_number(char *path)
 {
 	char *c;
 
-	c = strstr(path, driver->hc_device->bus_id);
-	if(!c) 
+	c = strstr(path, vhci_driver->hc_device->bus_id);
+	if (!c)
 		return -1;	/* hc exist? */
 	c++;
 	/* -> usb6/6-1/6-1:1.1 */
 
 	c = strchr(c, '/');
-	if(!c)
+	if (!c)
 		return -1;	/* hc exist? */
 	c++;
 	/* -> 6-1/6-1:1.1 */
 
 	c = strchr(c, '/');
-	if(!c) 
+	if (!c)
 		return -1;	/* no interface path */
 	c++;
 	/* -> 6-1:1.1 */
 
 	c = strchr(c, ':');
-	if(!c)
+	if (!c)
 		return -1;	/* no configuration? */
 	c++;
 	/* -> 1.1 */
 
 	c = strchr(c, '.');
-	if(!c)
+	if (!c)
 		return -1;	/* no interface? */
 	c++;
 	/* -> 1 */
@@ -66,7 +66,7 @@
 			udev->busid, udev->bConfigurationValue, i);
 
 	suinf = sysfs_open_device("usb", busid);
-	if(!suinf)
+	if (!suinf)
 		err("sysfs_open_device %s", busid);
 
 	return suinf;
@@ -89,7 +89,7 @@
 	if (fd < 0)
 		return -1;
 
-	snprintf(buff, MAX_BUFF, "%s %s %s\n", 
+	snprintf(buff, MAX_BUFF, "%s %s %s\n",
 			host, port, busid);
 
 	ret = write(fd, buff, strlen(buff));
@@ -124,7 +124,7 @@
 }
 
 
-void usbip_vhci_imported_device_dump(struct usbip_vhci_driver *driver, struct usbip_imported_device *idev)
+void usbip_vhci_imported_device_dump(struct usbip_imported_device *idev)
 {
 	char product_name[100];
 	char host[NI_MAXHOST] = "unknown host";
@@ -132,19 +132,19 @@
 	char remote_busid[SYSFS_BUS_ID_SIZE];
 	int ret;
 
-	if(idev->status == VDEV_ST_NULL || idev->status == VDEV_ST_NOTASSIGNED) {
+	if (idev->status == VDEV_ST_NULL || idev->status == VDEV_ST_NOTASSIGNED) {
 		info("Port %02d: <%s>", idev->port, usbip_status_string(idev->status));
 		return;
 	}
 
 	ret = read_record(idev->port, host, serv, remote_busid);
-	if(ret)
+	if (ret)
 		err("red_record");
 
 	info("Port %02d: <%s> at %s", idev->port,
 			usbip_status_string(idev->status), usbip_speed_string(idev->udev.speed));
 
-	usbip_product_name(product_name, sizeof(product_name),
+	usbip_names_get_product(product_name, sizeof(product_name),
 			idev->udev.idVendor, idev->udev.idProduct);
 
 	info("       %s",  product_name);
@@ -153,13 +153,14 @@
 			idev->udev.busid, host, serv, remote_busid,
 			idev->busnum, idev->devnum);
 
-	for(int i=0; i < idev->udev.bNumInterfaces; i++) {
+	for (int i=0; i < idev->udev.bNumInterfaces; i++) {
 		/* show interface information */
 		struct sysfs_device *suinf;
 
 		suinf = open_usb_interface(&idev->udev, i);
-		if(!suinf)
+		if (!suinf)
 			continue;
+
 		info("       %6s used by %-17s", suinf->bus_id, suinf->driver_name);
 		sysfs_close_device(suinf);
 
@@ -167,8 +168,8 @@
 		struct class_device *cdev;
 
 		dlist_for_each_data(idev->cdev_list, cdev, struct class_device) {
-			int ifnum = get_interface_number(driver, cdev->devpath);
-			if(ifnum == i) {
+			int ifnum = get_interface_number(cdev->devpath);
+			if (ifnum == i) {
 				info("           %s", cdev->clspath);
 			}
 		}
@@ -188,18 +189,18 @@
 
 	/* get all possible addresses */
 	err = getaddrinfo(hostname, service, &hints, &res0);
-	if(err) {
+	if (err) {
 		err("%s %s: %s", hostname, service, gai_strerror(err));
 		return -1;
 	}
 
 	/* try all the addresses */
-	for(res = res0; res; res = res->ai_next) {
+	for (res = res0; res; res = res->ai_next) {
 		char hbuf[NI_MAXHOST], sbuf[NI_MAXSERV];
 
 		err = getnameinfo(res->ai_addr, res->ai_addrlen,
 				hbuf, sizeof(hbuf), sbuf, sizeof(sbuf), NI_NUMERICHOST | NI_NUMERICSERV);
-		if(err) {
+		if (err) {
 			err("%s %s: %s", hostname, service, gai_strerror(err));
 			continue;
 		}
@@ -207,13 +208,18 @@
 		dbg("trying %s port %s\n", hbuf, sbuf);
 
 		sockfd = socket(res->ai_family, res->ai_socktype, res->ai_protocol);
-		if(sockfd < 0) {
+		if (sockfd < 0) {
 			err("socket");
 			continue;
 		}
 
+		/* should set TCP_NODELAY for usbip */
+		usbip_set_nodelay(sockfd);
+		/* TODO: write code for heatbeat */
+		usbip_set_keepalive(sockfd);
+
 		err = connect(sockfd, res->ai_addr, res->ai_addrlen);
-		if(err < 0) {
+		if (err < 0) {
 			close(sockfd);
 			continue;
 		}
@@ -242,19 +248,19 @@
 	bzero(&rep, sizeof(rep));
 
 	ret = usbip_send_op_common(sockfd, OP_REQ_DEVLIST, 0);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("send op_common");
 		return -1;
 	}
 
 	ret = usbip_recv_op_common(sockfd, &code);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv op_common");
 		return -1;
 	}
 
 	ret = usbip_recv(sockfd, (void *) &rep, sizeof(rep));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv op_devlist");
 		return -1;
 	}
@@ -262,7 +268,7 @@
 	PACK_OP_DEVLIST_REPLY(0, &rep);
 	dbg("exportable %d devices", rep.ndev);
 
-	for(unsigned int i=0; i < rep.ndev; i++) {
+	for (unsigned int i=0; i < rep.ndev; i++) {
 		char product_name[100];
 		char class_name[100];
 		struct usb_device udev;
@@ -270,32 +276,32 @@
 		bzero(&udev, sizeof(udev));
 
 		ret = usbip_recv(sockfd, (void *) &udev, sizeof(udev));
-		if(ret < 0) {
+		if (ret < 0) {
 			err("recv usb_device[%d]", i);
 			return -1;
 		}
 		pack_usb_device(0, &udev);
 
-		usbip_product_name(product_name, sizeof(product_name),
+		usbip_names_get_product(product_name, sizeof(product_name),
 				udev.idVendor, udev.idProduct);
-		usbip_class_name(class_name, sizeof(class_name), udev.bDeviceClass,
+		usbip_names_get_class(class_name, sizeof(class_name), udev.bDeviceClass,
 				udev.bDeviceSubClass, udev.bDeviceProtocol);
 
 		info("%8s: %s", udev.busid, product_name);
 		info("%8s: %s", " ", udev.path);
 		info("%8s: %s", " ", class_name);
 
-		for(int j=0; j < udev.bNumInterfaces; j++) {
+		for (int j=0; j < udev.bNumInterfaces; j++) {
 			struct usb_interface uinf;
 
 			ret = usbip_recv(sockfd, (void *) &uinf, sizeof(uinf));
-			if(ret < 0) {
+			if (ret < 0) {
 				err("recv usb_interface[%d]", j);
 				return -1;
 			}
 
 			pack_usb_interface(0, &uinf);
-			usbip_class_name(class_name, sizeof(class_name), uinf.bInterfaceClass,
+			usbip_names_get_class(class_name, sizeof(class_name), uinf.bInterfaceClass,
 					uinf.bInterfaceSubClass, uinf.bInterfaceProtocol);
 
 			info("%8s: %2d - %s", " ", j, class_name);
@@ -310,30 +316,30 @@
 static int import_device(int sockfd, struct usb_device *udev)
 {
 	int ret;
-	struct usbip_vhci_driver *driver;
 	int port;
 
-	driver = usbip_vhci_driver_open();
-	if(!driver) {
+	ret = usbip_vhci_driver_open();
+	if (ret < 0) {
 		err("open vhci_driver");
 		return -1;
 	}
 
-	port = usbip_vhci_get_free_port(driver);
-	if(port < 0) {
+	port = usbip_vhci_get_free_port();
+	if (port < 0) {
 		err("no free port");
-		usbip_vhci_driver_close(driver);
+		usbip_vhci_driver_close();
 		return -1;
 	}
 
-	ret = usbip_vhci_import_device(driver, port, sockfd, udev);
-	if(ret < 0) {
+	ret = usbip_vhci_attach_device(port, sockfd, udev->busnum,
+			udev->devnum, udev->speed);
+	if (ret < 0) {
 		err("import device");
-		usbip_vhci_driver_close(driver);
+		usbip_vhci_driver_close();
 		return -1;
 	}
 
-	usbip_vhci_driver_close(driver);
+	usbip_vhci_driver_close();
 
 	return port;
 }
@@ -352,7 +358,7 @@
 
 	/* send a request */
 	ret = usbip_send_op_common(sockfd, OP_REQ_IMPORT, 0);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("send op_common");
 		return -1;
 	}
@@ -362,7 +368,7 @@
 	PACK_OP_IMPORT_REQUEST(0, &request);
 
 	ret = usbip_send(sockfd, (void *) &request, sizeof(request));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("send op_import_request");
 		return -1;
 	}
@@ -370,13 +376,13 @@
 
 	/* recieve a reply */
 	ret = usbip_recv_op_common(sockfd, &code);
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv op_common");
 		return -1;
 	}
 
 	ret = usbip_recv(sockfd, (void *) &reply, sizeof(reply));
-	if(ret < 0) {
+	if (ret < 0) {
 		err("recv op_import_reply");
 		return -1;
 	}
@@ -385,7 +391,7 @@
 
 
 	/* check the reply */
-	if(strncmp(reply.udev.busid, busid, SYSFS_BUS_ID_SIZE)) {
+	if (strncmp(reply.udev.busid, busid, SYSFS_BUS_ID_SIZE)) {
 		err("recv different busid %s", reply.udev.busid);
 		return -1;
 	}
@@ -402,13 +408,13 @@
 	int rhport;
 
 	sockfd = tcp_connect(host, USBIP_PORT_STRING);
-	if(sockfd < 0) {
+	if (sockfd < 0) {
 		err("tcp connect");
 		return;
 	}
 
 	rhport = query_import_device(sockfd, busid);
-	if(rhport < 0) {
+	if (rhport < 0) {
 		err("query");
 		return;
 	}
@@ -417,7 +423,7 @@
 
 	ret = record_connection(host, USBIP_PORT_STRING,
 			busid, rhport);
-	if (ret < 0) 
+	if (ret < 0)
 		err("record connection");
 
 	return;
@@ -425,11 +431,11 @@
 
 static void detach_port(char *port)
 {
-	struct usbip_vhci_driver *driver;
+	int ret;
 	uint8_t portnum;
 
-	for(unsigned int i=0; i < strlen(port); i++)
-		if(!isdigit(port[i])) {
+	for (unsigned int i=0; i < strlen(port); i++)
+		if (!isdigit(port[i])) {
 			err("invalid port %s", port);
 			return;
 		}
@@ -438,15 +444,15 @@
 
 	portnum = atoi(port);
 
-	driver = usbip_vhci_driver_open();
-	if(!driver) {
+	ret = usbip_vhci_driver_open();
+	if (ret < 0) {
 		err("open vhci_driver");
 		return;
 	}
 
-	usbip_vhci_detach_device(driver, portnum);
+	usbip_vhci_detach_device(portnum);
 
-	usbip_vhci_driver_close(driver);
+	usbip_vhci_driver_close();
 }
 
 static void show_exported_devices(char *host)
@@ -455,7 +461,7 @@
 	int sockfd;
 
 	sockfd = tcp_connect(host, USBIP_PORT_STRING);
-	if(sockfd < 0) {
+	if (sockfd < 0) {
 		info("- %s failed", host);
 		return;
 	}
@@ -463,6 +469,82 @@
 	info("- %s", host);
 
 	ret = query_exported_devices(sockfd);
+	if (ret < 0) {
+		err("query");
+	}
+
+	close(sockfd);
+}
+
+static int attach_exported_devices(char *host, int sockfd)
+{
+	int ret;
+	struct op_devlist_reply rep;
+	uint16_t code = OP_REP_DEVLIST;
+
+	bzero(&rep, sizeof(rep));
+
+	ret = usbip_send_op_common(sockfd, OP_REQ_DEVLIST, 0);
+	if(ret < 0) {
+		err("send op_common");
+		return -1;
+	}
+
+	ret = usbip_recv_op_common(sockfd, &code);
+	if(ret < 0) {
+		err("recv op_common");
+		return -1;
+	}
+
+	ret = usbip_recv(sockfd, (void *) &rep, sizeof(rep));
+	if(ret < 0) {
+		err("recv op_devlist");
+		return -1;
+	}
+
+	PACK_OP_DEVLIST_REPLY(0, &rep);
+	dbg("exportable %d devices", rep.ndev);
+
+	for(unsigned int i=0; i < rep.ndev; i++) {
+		char product_name[100];
+		char class_name[100];
+		struct usb_device udev;
+
+		bzero(&udev, sizeof(udev));
+
+		ret = usbip_recv(sockfd, (void *) &udev, sizeof(udev));
+		if(ret < 0) {
+			err("recv usb_device[%d]", i);
+			return -1;
+		}
+		pack_usb_device(0, &udev);
+
+		usbip_names_get_product(product_name, sizeof(product_name),
+				udev.idVendor, udev.idProduct);
+		usbip_names_get_class(class_name, sizeof(class_name), udev.bDeviceClass,
+				udev.bDeviceSubClass, udev.bDeviceProtocol);
+
+		dbg("Attaching usb port %s from host %s on usbip, with deviceid: %s", udev.busid, host, product_name);
+		attach_device(host, udev.busid);
+	}
+
+	return rep.ndev;
+}
+
+static void attach_devices_all(char *host)
+{
+	int ret;
+	int sockfd;
+
+	sockfd = tcp_connect(host, USBIP_PORT_STRING);
+	if(sockfd < 0) {
+		info("- %s failed", host);
+		return;
+	}
+
+	info("- %s", host);
+
+	ret = attach_exported_devices(host, sockfd);
 	if(ret < 0) {
 		err("query");
 	}
@@ -476,6 +558,9 @@
 	-a, --attach [host] [bus_id]		\n\
 		Attach a remote USB device.	\n\
 						\n\
+	-x, --attachall [host]		\n\
+		Attach all remote USB devices on the specific host.	\n\
+						\n\
 	-d, --detach [ports]			\n\
 		Detach an imported USB device.	\n\
 						\n\
@@ -499,29 +584,30 @@
 	printf("%s", help_message);
 }
 
-static void show_port_status(void) 
+static void show_port_status(void)
 {
+	int ret;
 	struct usbip_imported_device *idev;
-	struct usbip_vhci_driver *driver;
 
-	driver = usbip_vhci_driver_open();
-	if(!driver) {
+	ret = usbip_vhci_driver_open();
+	if (ret < 0)
 		return;
-	}
 
-	for(int i = 0; i < driver->nports; i++) {
-		idev = &driver->idev[i];
 
-		usbip_vhci_imported_device_dump(driver, idev);
+	for (int i = 0; i < vhci_driver->nports; i++) {
+		idev = &vhci_driver->idev[i];
+
+		usbip_vhci_imported_device_dump(idev);
 	}
 
-	usbip_vhci_driver_close(driver);
+	usbip_vhci_driver_close();
 }
 
 #define _GNU_SOURCE
 #include <getopt.h>
 static const struct option longopts[] = {
 	{"attach",	no_argument,	NULL, 'a'},
+	{"attachall",	no_argument,	NULL, 'x'},
 	{"detach",	no_argument,	NULL, 'd'},
 	{"port",	no_argument,	NULL, 'p'},
 	{"list",	no_argument,	NULL, 'l'},
@@ -538,6 +624,7 @@
 
 	enum {
 		cmd_attach = 1,
+		cmd_attachall,
 		cmd_detach,
 		cmd_port,
 		cmd_list,
@@ -547,49 +634,55 @@
 
 	usbip_use_stderr = 1;
 
- 	ret = names_init(USBIDS_FILE);
- 	if(ret)
+ 	ret = usbip_names_init(USBIDS_FILE);
+ 	if (ret)
  		err("open usb.ids");
 
-	while(1) {
+	for (;;) {
 		int c;
 		int index = 0;
 
-		c = getopt_long(argc, argv, "adplvhDS", longopts, &index);
+		c = getopt_long(argc, argv, "adplvhDSx", longopts, &index);
 
-		if(c == -1)
+		if (c == -1)
 			break;
 
 		switch(c) {
 			case 'a':
-				if(!cmd)
+				if (!cmd)
 					cmd = cmd_attach;
 				else
 					cmd = cmd_help;
 				break;
 			case 'd':
-				if(!cmd)
+				if (!cmd)
 					cmd = cmd_detach;
 				else
 					cmd = cmd_help;
 				break;
 			case 'p':
-				if(!cmd)
+				if (!cmd)
 					cmd = cmd_port;
 				else cmd = cmd_help;
 				break;
 			case 'l':
-				if(!cmd)
+				if (!cmd)
 					cmd = cmd_list;
 				else
 					cmd = cmd_help;
 				break;
 			case 'v':
-				if(!cmd)
+				if (!cmd)
 					cmd = cmd_version;
 				else
 					cmd = cmd_help;
 				break;
+			case 'x':
+				if(!cmd)
+					cmd = cmd_attachall;
+				else
+					cmd = cmd_help;
+				break;
 			case 'h':
 				cmd = cmd_help;
 				break;
@@ -610,22 +703,26 @@
 
 	switch(cmd) {
 		case cmd_attach:
-			if(optind == argc - 2)
+			if (optind == argc - 2)
 				attach_device(argv[optind], argv[optind+1]);
 			else
 				show_help();
 			break;
 		case cmd_detach:
-			while(optind < argc)
+			while (optind < argc)
 				detach_port(argv[optind++]);
 			break;
 		case cmd_port:
 			show_port_status();
 			break;
 		case cmd_list:
-			while(optind < argc)
+			while (optind < argc)
 				show_exported_devices(argv[optind++]);
 			break;
+		case cmd_attachall:
+			while(optind < argc)
+				attach_devices_all(argv[optind++]);
+			break;
 		case cmd_version:
 			printf("%s\n", version);
 			break;
@@ -637,7 +734,7 @@
 	}
 
 
-	names_deinit();
+	usbip_names_free();
 
 	return 0;
 }
diff -Naur usbip-0.1.4/src/configure.ac trunk/src/configure.ac
--- usbip-0.1.4/src/configure.ac	2007-05-18 11:10:10.000000000 +0200
+++ trunk/src/configure.ac	2007-05-18 11:10:08.000000000 +0200
@@ -2,8 +2,9 @@
 # Process this file with autoconf to produce a configure script.
 
 AC_PREREQ(2.59)
-AC_INIT(usbip, 0.1.4, taka-hir@is.naist.jp)
-AC_DEFINE(USBIP_VERSION, 0x000104, Numeric version number)
+AC_REVISION($Id: configure.ac 239 2006-12-26 09:51:23Z taka-hir $)
+AC_INIT(usbip, 0.1.5, taka-hir@is.naist.jp)
+AC_DEFINE(USBIP_VERSION, 0x000105, Numeric version number)
 
 AC_CONFIG_SRCDIR([config.h.in])
 AM_INIT_AUTOMAKE
@@ -38,44 +39,62 @@
 AC_CHECK_HEADER(sysfs/libsysfs.h,
 	[AC_CHECK_LIB(sysfs, sysfs_open_directory_list,
 		[LIBS="$LIBS -lsysfs"],
-	[AC_MSG_ERROR([Missing sysfs2 library!])])],
+		[AC_MSG_ERROR([Missing sysfs2 library!])])],
 	[AC_MSG_ERROR([Missing /usr/include/sysfs/libsysfs.h])])
 
 
 # get from stunnel
 dnl Check for libwrap library.
 AC_MSG_CHECKING([whether to use the libwrap (TCP wrappers) library])
+
 AC_ARG_WITH(tcp-wrappers,
-	[ --with-tcp-wrappers     Use the libwrap (TCP wrappers) library ],
-	[
-	   saved_LIBS="$LIBS"
-	   if test "$withval" = "yes"; then
-	       	    AC_MSG_RESULT([yes])
-	       	    AC_MSG_CHECKING([for hosts_access in -lwrap])
-	       	    LIBS="-lwrap $LIBS"
-	       	    AC_TRY_LINK([int hosts_access(); int allow_severity, deny_severity;],
-			    [hosts_access()],
-			    [AC_MSG_RESULT([yes]); AC_DEFINE(HAVE_LIBWRAP, 1, use tcp wrapper) wrap_LIB="-lwrap"],
-			    [AC_MSG_RESULT([not found]); exit 1])
-	   else
-	       	    AC_MSG_RESULT([no])
-	   fi
-	   LIBS="$saved_LIBS"
-	 ],
-	 [
-	    AC_MSG_RESULT([(default)])
-	    AC_MSG_CHECKING([for hosts_access in -lwrap])
-	    saved_LIBS="$LIBS"
-	    LIBS="-lwrap $saved_LIBS"
-	    AC_TRY_LINK([int hosts_access(); int allow_severity, deny_severity;],
-	            [hosts_access()],
-	            [AC_MSG_RESULT([yes]); AC_DEFINE(HAVE_LIBWRAP, 1, use tcp wrapper)],
-	            [AC_MSG_RESULT([no]); LIBS="$saved_LIBS"])
-	]
-    )
+[  --with-tcp-wrappers     Use the libwrap (TCP wrappers) library ],
+[saved_LIBS="$LIBS"
+ if test "$withval" = "yes"; then
+      AC_MSG_RESULT([yes])
+      AC_MSG_CHECKING([for hosts_access in -lwrap])
+      LIBS="-lwrap $LIBS"
+      AC_TRY_LINK(
+	[int hosts_access(); int allow_severity, deny_severity;],
+	[hosts_access()],
+	[AC_MSG_RESULT([yes]); AC_DEFINE(HAVE_LIBWRAP, 1, use tcp wrapper) wrap_LIB="-lwrap"],
+	[AC_MSG_RESULT([not found]); exit 1])
+ else
+ 	     AC_MSG_RESULT([no])
+ fi
+ LIBS="$saved_LIBS"],
+[AC_MSG_RESULT([(default)])
+ AC_MSG_CHECKING([for hosts_access in -lwrap])
+ saved_LIBS="$LIBS"
+ LIBS="-lwrap $saved_LIBS"
+ AC_TRY_LINK(
+	[int hosts_access(); int allow_severity, deny_severity;],
+ 	[hosts_access()],
+ 	[AC_MSG_RESULT([yes]); AC_DEFINE(HAVE_LIBWRAP, 1, use tcp wrapper)],
+ 	[AC_MSG_RESULT([no]); LIBS="$saved_LIBS"])
+])
+
+
+
+USBIDS_DIR='${datadir}/usbip'
+AC_ARG_WITH(usbids-dir, [  --with-usbids-dir=DIR   where usb.ids is found (default ${datadir}/usbip)], [USBIDS_DIR=$withval])
+AC_SUBST(USBIDS_DIR)
+
+dnl FIXME: when disabled, empty directry is created
+usbids=install
+AC_ARG_ENABLE(usbids-install,
+[  --enable-usbids-install     install usb.ids (default)],
+[case "${enableval}" in
+ yes) usbids=install ;;
+ no)  usbids=notinstall ;;
+ *)   AC_MSG_ERROR(bad value ${enableval} for --enable-usbids-install) ;;
+ esac])
+AM_CONDITIONAL(INSTALL_USBIDS, test x$usbids = xinstall)
+    	
+
 
-pkg_modules="glib-2.0"
-PKG_CHECK_MODULES(PACKAGE, [$pkg_modules])
+GLIB2_REQUIRED=2.6.0
+PKG_CHECK_MODULES(PACKAGE, glib-2.0 >= $GLIB2_REQUIRED)
 AC_SUBST(PACKAGE_CFLAGS)
 AC_SUBST(PACKAGE_LIBS)
 
diff -Naur usbip-0.1.4/src/INSTALL trunk/src/INSTALL
--- usbip-0.1.4/src/INSTALL	2007-05-18 11:10:10.000000000 +0200
+++ trunk/src/INSTALL	2007-05-18 11:10:08.000000000 +0200
@@ -1,8 +1,8 @@
 Installation Instructions
 *************************
 
-Copyright (C) 1994, 1995, 1996, 1999, 2000, 2001, 2002, 2004, 2005 Free
-Software Foundation, Inc.
+Copyright (C) 1994, 1995, 1996, 1999, 2000, 2001, 2002, 2004, 2005,
+2006 Free Software Foundation, Inc.
 
 This file is free documentation; the Free Software Foundation gives
 unlimited permission to copy, distribute and modify it.
@@ -10,7 +10,10 @@
 Basic Installation
 ==================
 
-These are generic installation instructions.
+Briefly, the shell commands `./configure; make; make install' should
+configure, build, and install this package.  The following
+more-detailed instructions are generic; see the `README' file for
+instructions specific to this package.
 
    The `configure' shell script attempts to guess correct values for
 various system-dependent variables used during compilation.  It uses
@@ -23,9 +26,9 @@
 
    It can also use an optional file (typically called `config.cache'
 and enabled with `--cache-file=config.cache' or simply `-C') that saves
-the results of its tests to speed up reconfiguring.  (Caching is
+the results of its tests to speed up reconfiguring.  Caching is
 disabled by default to prevent problems with accidental use of stale
-cache files.)
+cache files.
 
    If you need to do unusual things to compile the package, please try
 to figure out how `configure' could check whether to do them, and mail
@@ -35,20 +38,17 @@
 may remove or edit it.
 
    The file `configure.ac' (or `configure.in') is used to create
-`configure' by a program called `autoconf'.  You only need
-`configure.ac' if you want to change it or regenerate `configure' using
-a newer version of `autoconf'.
+`configure' by a program called `autoconf'.  You need `configure.ac' if
+you want to change it or regenerate `configure' using a newer version
+of `autoconf'.
 
 The simplest way to compile this package is:
 
   1. `cd' to the directory containing the package's source code and type
-     `./configure' to configure the package for your system.  If you're
-     using `csh' on an old version of System V, you might need to type
-     `sh ./configure' instead to prevent `csh' from trying to execute
-     `configure' itself.
+     `./configure' to configure the package for your system.
 
-     Running `configure' takes awhile.  While running, it prints some
-     messages telling which features it is checking for.
+     Running `configure' might take a while.  While running, it prints
+     some messages telling which features it is checking for.
 
   2. Type `make' to compile the package.
 
@@ -78,7 +78,7 @@
 by setting variables in the command line or in the environment.  Here
 is an example:
 
-     ./configure CC=c89 CFLAGS=-O2 LIBS=-lposix
+     ./configure CC=c99 CFLAGS=-g LIBS=-lposix
 
    *Note Defining Variables::, for more details.
 
@@ -87,17 +87,15 @@
 
 You can compile the package for more than one kind of computer at the
 same time, by placing the object files for each architecture in their
-own directory.  To do this, you must use a version of `make' that
-supports the `VPATH' variable, such as GNU `make'.  `cd' to the
+own directory.  To do this, you can use GNU `make'.  `cd' to the
 directory where you want the object files and executables to go and run
 the `configure' script.  `configure' automatically checks for the
 source code in the directory that `configure' is in and in `..'.
 
-   If you have to use a `make' that does not support the `VPATH'
-variable, you have to compile the package for one architecture at a
-time in the source code directory.  After you have installed the
-package for one architecture, use `make distclean' before reconfiguring
-for another architecture.
+   With a non-GNU `make', it is safer to compile the package for one
+architecture at a time in the source code directory.  After you have
+installed the package for one architecture, use `make distclean' before
+reconfiguring for another architecture.
 
 Installation Names
 ==================
@@ -190,12 +188,12 @@
      ./configure CC=/usr/local2/bin/gcc
 
 causes the specified `gcc' to be used as the C compiler (unless it is
-overridden in the site shell script).  Here is a another example:
+overridden in the site shell script).
 
-     /bin/bash ./configure CONFIG_SHELL=/bin/bash
+Unfortunately, this technique does not work for `CONFIG_SHELL' due to
+an Autoconf bug.  Until the bug is fixed you can use this workaround:
 
-Here the `CONFIG_SHELL=/bin/bash' operand causes subsequent
-configuration-related scripts to be executed by `/bin/bash'.
+     CONFIG_SHELL=/bin/bash /bin/bash ./configure CONFIG_SHELL=/bin/bash
 
 `configure' Invocation
 ======================
diff -Naur usbip-0.1.4/src/lib/Makefile.am trunk/src/lib/Makefile.am
--- usbip-0.1.4/src/lib/Makefile.am	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/lib/Makefile.am	2007-05-18 11:10:07.000000000 +0200
@@ -1,8 +1,10 @@
 # AM_CFLAGS = -Wall -std=gnu99
 lib_LTLIBRARIES = libusbip.la
 libusbip_la_SOURCES = names.c names.h stub_driver.c stub_driver.h usbip.h usbip_common.c usbip_common.h vhci_driver.c vhci_driver.h
-AM_CPPFLAGS = -I../include -Wall -std=gnu99
+#libusbip_la_SOURCES = names.c names.h stub_driver.c usbip_common.c vhci_driver.c
+#INCLUDES = -I../include
+#AM_CPPFLAGS = -I../include -Wall -std=gnu99
 libusbip_la_LDFLAGS = -version-info 0:1:0
 EXTRA_CFLAGS = @EXTRA_CLFAGS@
-libusbip_la_CFLAGS = -Wall -W -Wstrict-prototypes $(EXTRA_CLFAGS)
+libusbip_la_CFLAGS = -Wall -W -Wstrict-prototypes -std=gnu99 $(EXTRA_CLFAGS) -DUSBIDS_FILE='"@USBIDS_DIR@/usb.ids"'
 
diff -Naur usbip-0.1.4/src/lib/names.c trunk/src/lib/names.c
--- usbip-0.1.4/src/lib/names.c	2007-05-18 11:10:09.000000000 +0200
+++ trunk/src/lib/names.c	2007-05-18 11:10:07.000000000 +0200
@@ -239,27 +239,27 @@
 }
 
 /* ---------------------------------------------------------------------- */
+/* add a cleanup function by takahiro */
 
-/* add a cleanup function */
 struct pool {
 	struct pool *next;
 	void *mem;
 };
 
-struct pool *pool_head = NULL;
+static struct pool *pool_head = NULL;
 
 static void *my_malloc(size_t size)
 {
 	struct pool *p;
 
 	p = calloc(1, sizeof(struct pool));
-	if(!p) {
+	if (!p) {
 		free(p);
 		return NULL;
 	}
 
 	p->mem = calloc(1, size);
-	if(!p->mem)
+	if (!p->mem)
 		return NULL;
 
 	p->next = pool_head;
@@ -268,17 +268,17 @@
 	return p->mem;
 }
 
-void names_deinit(void)
+void names_free(void)
 {
 	struct pool *pool;
 
-	if(!pool_head)
+	if (!pool_head)
 		return;
 
-	for(pool = pool_head; pool != NULL; ) {
+	for (pool = pool_head; pool != NULL; ) {
 		struct pool *tmp;
 
-		if(pool->mem)
+		if (pool->mem)
 			free(pool->mem);
 
 		tmp = pool;
@@ -411,7 +411,7 @@
 {
         struct genericstrtable *g;
 	unsigned int h = hashnum(index);
-        
+
         for (g = t[h]; g; g = g->next)
                 if (g->num == index)
                         return -1;
@@ -466,7 +466,7 @@
 
 /* ---------------------------------------------------------------------- */
 
-#define DBG(x) 
+#define DBG(x)
 
 static void parse(FILE *f)
 {
@@ -769,7 +769,7 @@
                         DBG(printf("line %5u Report type %02x %s\n", linectr, u, cp));
                         continue;
 
-                }			
+                }
                 if (buf[0] == 'V' && buf[1] == 'T') {
 			/* add here */
 			continue;
@@ -783,7 +783,7 @@
 int names_init(char *n)
 {
 	FILE *f;
-	
+
 	if (!(f = fopen(n, "r"))) {
 		return errno;
 	}
diff -Naur usbip-0.1.4/src/lib/names.h trunk/src/lib/names.h
--- usbip-0.1.4/src/lib/names.h	1970-01-01 01:00:00.000000000 +0100
+++ trunk/src/lib/names.h	2007-05-18 11:10:07.000000000 +0200
@@ -0,0 +1,57 @@
+/*****************************************************************************/
+
+/*
+ *      names.h  --  USB name database manipulation routines
+ *
+ *      Copyright (C) 1999, 2000  Thomas Sailer (sailer@ife.ee.ethz.ch)
+ *
+ *      This program is free software; you can redistribute it and/or modify
+ *      it under the terms of the GNU General Public License as published by
+ *      the Free Software Foundation; either version 2 of the License, or
+ *      (at your option) any later version.
+ *
+ *      This program is distributed in the hope that it will be useful,
+ *      but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *      GNU General Public License for more details.
+ *
+ *      You should have received a copy of the GNU General Public License
+ *      along with this program; if not, write to the Free Software
+ *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *
+ */
+
+/*
+ *	Copyright (C) 2005 Takahiro Hirofuchi
+ *	       - names_free() is added.
+ */
+
+/*****************************************************************************/
+
+#ifndef _NAMES_H
+#define _NAMES_H
+
+#include <sys/types.h>
+
+/* ---------------------------------------------------------------------- */
+
+extern const char *names_vendor(u_int16_t vendorid);
+extern const char *names_product(u_int16_t vendorid, u_int16_t productid);
+extern const char *names_class(u_int8_t classid);
+extern const char *names_subclass(u_int8_t classid, u_int8_t subclassid);
+extern const char *names_protocol(u_int8_t classid, u_int8_t subclassid, u_int8_t protocolid);
+extern const char *names_audioterminal(u_int16_t termt);
+extern const char *names_hid(u_int8_t hidd);
+extern const char *names_reporttag(u_int8_t rt);
+extern const char *names_huts(unsigned int data);
+extern const char *names_hutus(unsigned int data);
+extern const char *names_langid(u_int16_t langid);
+extern const char *names_physdes(u_int8_t ph);
+extern const char *names_bias(u_int8_t b);
+extern const char *names_countrycode(unsigned int countrycode);
+extern int  names_init(char *n);
+extern void names_free(void);
+
+/* ---------------------------------------------------------------------- */
+#endif /* _NAMES_H */
